/*================================================================================================*
 * Обмен данными и командами с ПЛИС
 *================================================================================================*/

#ifndef CPLD_H_
#define CPLD_H_

#include "global.h"
#include "settings.h"

/*================================================================================================*/
/* Размер буфера приемника задается блоками 16-битных слов */
#define CPLD_RXBUF_BLKLEN       0x800
#define CPLD_RXBUF_NBLOCKS      8
#define CPLD_RXBUF_DECL         __attribute__ ((section(".bss2")))
#define CPLD_RXBUF_LEN          (CPLD_RXBUF_NBLOCKS * CPLD_RXBUF_BLKLEN)

#if !SET_USE_M0_CORE
/* Размер буфера передатчика задается в 16-битных словах; буфер состоит из 2 половин */
#define CPLD_TXBUF_HALFLEN      0xFFF
#define CPLD_TXBUF_DECL         __attribute__ ((section(".bss3")))
#define CPLD_TXBUF_LEN          (2 * CPLD_TXBUF_HALFLEN)
#endif

#define CPLD_RX_DMA_PTR         ((volatile const uint16_t*)LPC_GPDMA->CH[SET_DMACH_SSP_IN_RX].DESTADDR)

/* Если CPLD_RX_DMA_IRQ_BITS == 1, то в конфигурации канала DMA на прием данных включаются запросы
   прерывания по окончанию передачи одного блока.
   (само прерывание DMA через NVIC в cpld.c не включается и обработчика нет,
   но его может использовать верхний уровень) */
#define CPLD_RX_DMA_IRQ_BITS    1

/* Параметры интерфейса регистров ПЛИС */
#define CPLD_REGS_MAX           64  /* максимальное количество регистров */
#define CPLD_REGS_TIMEOUT_uS    100 /* таймаут, мкс */
/*================================================================================================*/

/*================================================================================================*/
/* Буфер чтения */
extern volatile uint16_t g_cpld_recv_buf[CPLD_RXBUF_LEN];
extern volatile const uint16_t* volatile g_cpld_recv_rptr;

/* Признак присутствия модуля (обновляется cpld_worker) */
extern uint8_t g_cpld_module_mask;  /* 1 = модуль присутствует */
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void cpld_init(void);
/*------------------------------------------------------------------------------------------------*/
void cpld_start(void);
/*------------------------------------------------------------------------------------------------*/
void cpld_stop(void);
/*------------------------------------------------------------------------------------------------*/
static inline size_t cpld_recv_words_avail(void)
    {
    volatile const uint16_t* head = g_cpld_recv_rptr;
    volatile const uint16_t* tail = CPLD_RX_DMA_PTR;
    return (size_t)((tail >= head) ? tail - head : CPLD_RXBUF_LEN + tail - head);
    }
/*------------------------------------------------------------------------------------------------*/
static inline uint16_t cpld_recv_get_word(void)
    {
    volatile const uint16_t* head = g_cpld_recv_rptr;
    uint16_t data = *head & 0x3FF;
    if (++head >= g_cpld_recv_buf + CPLD_RXBUF_LEN)
        head = g_cpld_recv_buf;
    g_cpld_recv_rptr = head;
    return data;
    }
/*------------------------------------------------------------------------------------------------*/
int cpld_send_getspeed(void);
/*------------------------------------------------------------------------------------------------*/
void cpld_send_setspeed(int hi_speed);
/*------------------------------------------------------------------------------------------------*/
size_t cpld_send(volatile const uint16_t* buf, size_t nwords);
/*------------------------------------------------------------------------------------------------*/
int cpld_write_regs(unsigned int first_addr, const uint8_t* buf, size_t count);
/*------------------------------------------------------------------------------------------------*/
void cpld_worker(void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* CPLD_H_ */
